// library.cpp : An example of using inheritance and composition

#include <iostream>
#include <fstream>
#include <string>
using namespace std;

const int LIBSIZE = 2;  // number of things in the library

// this represents the generic object in the collection
// It is the parent class of the two classes that will actually be stored in the
// container. There will be no instances of this class.
class holding {
public:
	holding() {};
	holding(string n, int l, double c) { title = n; location = l; cost = c;}
	string get_title() { return title;}
	int get_location() { return location;};
	double get_cost() { return cost;}
	void set_title(string s) { title = s;}
	void set_location(int l) { location = l;}
	void set_cost( double c) { cost = c;}
	void print()
	{
		cout << "Title: " << title;
		cout << " Cost: " << cost << " Location:" << location << endl;
	}

protected:
	string title;  // title
	int location;  // shelf number
	double cost;   // cost in dollars
}; // holding

class book : public holding {
public:
	book(string a, int p) {
		author = a; pages=p;
	}
	book(string a, int p, int loc, double c, string t) {
		author = a; pages=p;
		location = loc; cost = c; title = t;
	}
	int get_pages() { return pages;}
	string get_author() { return author;}
	void set_pages(int p) { pages = p;}
	void set_author(string a) { author = a;}
	void print() 
	{
		holding::print();  // run the parent version
		cout << " written by " << author;
		cout << " with " << pages << " pages." << endl;
		cout << "----------------------" << endl;
	} 

protected:
	string author;
	int pages;
}; // book


class video : public holding {
public:
	video(string a, int p) {
		director = a; length=p;
	}
	video(string a, int p, int loc, double c, string t) {
		director = a; length=p;
		location = loc; cost = c; title = t;
	}
	int get_length() { return length;}
	string get_director() { return director;}
	void set_length(int p) { length = p;}
	void set_director(string a) { director = a;}
	void print() 
	{
		holding::print(); // run the parent version
		cout << " Directed by " << director;
		cout << " length " << length << endl;
		cout << "----------------------" << endl;
	}
private:
	string director;
	int length;
}; // video

int 
main(int argc, char* argv[])
{
	string author, title;
	int location;
	double cost;
	int pages;

	cout << "Enter the books title: ";
	getline(cin,title);
	cout << "Enter the books author: ";
	getline(cin,author);
	cout << "Enter the books location: ";
	cin >> location;
	cout << "Enter the books cost: ";
	cin >> cost;
	cout << "How many pages in the book?: ";
	cin >> pages;

	book b(author,pages,location,cost,title);
	b.print();
	return 0;
}
